BEGIN
	DECLARE
		expirationPeriod NUMBER;
		campaignQueueTableExists NUMBER;
	BEGIN

		SELECT COUNT(*) INTO campaignQueueTableExists FROM USER_TABLES WHERE TABLE_NAME = 'CampaignQueue';
		IF (campaignQueueTableExists = 0) THEN
			RETURN;
		END IF;

    SELECT "IntegerValue" INTO expirationPeriod FROM "SysSettingsValue" WHERE "SysSettingsId" = (
			SELECT "Id" FROM "SysSettings" WHERE "Code" = N'CampaignTriggeredQueueTimeout'
		);

    INSERT INTO "CampaignQueue" ("Id", "CreatedOn", "CreatedById", "ModifiedOn", "ModifiedById", "ProcessListeners", "ContactId", "CampaignItemId", "ExpirationPeriod")
	  SELECT
  		cs."Id",
  		cs."CreatedOn",
  		cs."CreatedById",
  		cs."ModifiedOn",
  		cs."ModifiedById",
  		cs."ProcessListeners",
  		cs."ContactId",
  		cs."CampaignItemId",
  		expirationPeriod
  	FROM "CampaignSignal" cs;

	END;
END;