BEGIN
	DECLARE
		participantsOpTableExists NUMBER;
	BEGIN

		SELECT COUNT(*) INTO participantsOpTableExists FROM USER_TABLES WHERE TABLE_NAME = 'CampaignParticipantOp';
		IF (participantsOpTableExists = 0) THEN
			RETURN;
		END IF;

	UPDATE "CampaignParticipantOp"
	SET "InitialCampaignItemId" =
	(
		SELECT "Id" FROM "CampaignItem"
		WHERE "CampaignElementType" = N'StartSignal, Sessioned' 
			AND "CampaignId" = "CampaignParticipantOp"."CampaignId"
			AND "IsDeleted" = 0
			AND ROWNUM = 1
	);

	END;
END;