/*
** Project: BPMonline
** DBMS   : Oracle
** Type   : Package
** Name   : tspkg_Update77To78
*/

CREATE OR REPLACE PACKAGE "tspkg_Update77To78" 
AS    
	FUNCTION "fn_IsObjectExist"(p_ObjectName IN VARCHAR2) RETURN NUMBER;

	FUNCTION "fn_IsRowsExist"(p_TableName IN VARCHAR2) RETURN NUMBER;

	FUNCTION "fn_HasColumnUId"(p_TableName IN VARCHAR2)	RETURN NUMBER;
	
    FUNCTION "fn_GetColumnUIdFromComment"(p_CommentValue IN VARCHAR2) RETURN VARCHAR2;

	FUNCTION "tsp_GetReferenceSchemaUId"(p_CommentValue IN VARCHAR2) RETURN VARCHAR2;
	
    PROCEDURE "tsp_DropLczTables"  (p_LczTableName IN VARCHAR2);

    PROCEDURE "tsp_RestoreTableData"  (p_SourceName IN VARCHAR2,
		p_DestinationName IN VARCHAR2, p_PrimaryCulture IN VARCHAR2);
		

END "tspkg_Update77To78";
